Index: trunk/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOPersonApproval.cs
===================================================================
--- trunk/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOPersonApproval.cs	(nonexistent)
+++ trunk/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOPersonApproval.cs	(revision 52)
@@ -0,0 +1,518 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Collections;
+
+using log4net;
+using Oracle.ManagedDataAccess.Client;
+
+using ProcessManagement.DB.Oracle;
+using ProcessManagement.DB.Core;
+using ProcessManagement.DataModel;
+
+using ProcessManagement.Common;
+
+namespace ProcessManagement.DB.IOAccess
+{
+    /// <summary>
+    /// 担当者承認データアクセスクラス
+    /// </summary>
+    public class IOPersonApproval : OracleProcess
+    {
+        #region 定義部
+        /// <summary>
+        /// log4netログを使用する
+        /// </summary>
+        private static readonly ILog logger = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 承認データフィールド並び
+        /// </summary>
+        public enum ColumnName
+        {
+            PersonCode = 0,
+            ApprovalCode,
+            OrderDate,
+            OrderNo,
+            SeqNo,
+            PersonCodeApproval,
+            PetitionApprovalDate,
+            ApprovalLimitDates,
+            ApprovalStatus,
+            ENTRYDATE,
+            UPDATEDATE
+        }
+        #endregion
+
+        #region コンストラクタ
+        /// <summary>
+        /// コンストラクタ
+        /// </summary>
+        /// <param name="ConnectionString"></param>
+        public IOPersonApproval()
+            : base(DBCommon.Instance.DBConnectString)
+        {
+        }
+
+        #endregion
+
+        #region 承認データ検索文字列作成
+        /// <summary>
+        /// 承認データ検索文字列作成
+        /// </summary>
+        /// <param name="AddSQLString">検索条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        private string CreateSelectSQL()
+        {
+            // SQL作成（oracleのDateTime型が変換できないのでCharに変換しておく）
+            string strcmd = "SELECT";
+            strcmd += " PersonCode";
+            strcmd += ",ApprovalCode";
+            strcmd += ",OrderDate";
+            strcmd += ",OrderNo";
+            strcmd += ",SeqNo";
+            strcmd += ",PersonCodeApproval";
+            strcmd += ",TO_CHAR(PetitionApprovalDate, 'YYYY/MM/DD HH24:MI:ss')";
+            strcmd += ",TO_CHAR(ApprovalLimitDates, 'YYYY/MM/DD HH24:MI:ss')";
+            strcmd += ",ApprovalStatus";
+            strcmd += ",TO_CHAR(EntryDate, 'YYYY/MM/DD HH24:MI:ss')";
+            strcmd += ",TO_CHAR(UpdateDate, 'YYYY/MM/DD HH24:MI:ss')";
+            strcmd += " FROM PersonApproval";
+
+            return strcmd;
+        }
+        #endregion
+
+        #region 承認データ検索（複数）
+        /// <summary>
+        /// 承認データ検索（複数）
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool SelectAction(string AddSQLString, ref List<PersonApproval> data, bool bConnect = true)
+        {
+            //Oracle インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // SQL作成
+                strcmd = CreateSelectSQL() + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return false;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    PersonApproval work = new PersonApproval();
+                    Reader2Struct(objwrk, ref work);
+                    data.Add(work);
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+
+        }
+        #endregion
+
+        #region 承認データ検索（1件）
+        /// <summary>
+        /// 承認データ検索（1件）
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool SelectAction(string AddSQLString, ref PersonApproval data, bool bConnect = true)
+        {
+            //Oracle インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // SQL作成
+                strcmd = CreateSelectSQL() + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return false;
+                if (arData.Count == 0) return false;
+
+                // データセット
+                object[] objwrk = (object[])arData[0];
+                Reader2Struct(objwrk, ref data);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+
+        }
+        #endregion
+
+        #region 承認データ追加（複数）
+        /// <summary>
+        /// 承認データ追加（複数）
+        /// </summary>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool InsertAction(List<PersonApproval> data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+                foreach (PersonApproval work in data)
+                {
+                    if (!InsertAction(work, bConnect)) return false;
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ追加（1件）
+        /// <summary>
+        /// 承認データ追加（1件）
+        /// </summary>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool InsertAction(PersonApproval data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+
+                strcmd = "INSERT INTO PersonApproval";
+                strcmd += " (PersonCode";
+                strcmd += ",ApprovalCode";
+                strcmd += ",OrderDate";
+                strcmd += ",OrderNo";
+                strcmd += ",SeqNo";
+                strcmd += ",PersonCodeApproval";
+                strcmd += ",PetitionApprovalDate";
+                strcmd += ",ApprovalLimitDates";
+                strcmd += ",ApprovalStatus";
+                strcmd += ",EntryDate";
+                strcmd += ",UpdateDate)";
+
+                strcmd += " VALUES (";
+
+                strcmd += string.Format("  {0}", data.PersonCode.ToString());
+                strcmd += string.Format(", {0}", data.ApprovalCode.ToString());
+                strcmd += string.Format(", TO_DATE('{0}','YYYY/MM/DD')", data.OrderDate.ToShortDateString());
+                strcmd += string.Format(", {0}", data.OrderNo.ToString());
+                strcmd += string.Format(", {0}", data.SeqNo.ToString());
+                strcmd += string.Format(", {0}", data.PersonCodeApproval.ToString());
+                strcmd += string.Format(", TO_DATE('{0}','YYYY/MM/DD HH24:MI:SS')", data.PetitionApprovalDate.ToString());
+
+                strcmd += string.Format(", TO_DATE('{0}','YYYY/MM/DD HH24:MI:SS')", data.ApprovalLimitDates.ToString());
+                strcmd += string.Format(", {0}", data.ApprovalStatus.ToString());
+
+                strcmd += ", TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+                strcmd += ", TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+                strcmd = strcmd + ")";
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ更新
+        /// <summary>
+        /// 承認データ更新
+        /// </summary>
+        /// <param name="AddSQLString">更新条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool UpdateAction(string AddSQLString, PersonApproval data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+
+                strcmd = "UPDATE PersonApproval";
+
+                strcmd += " SET";
+
+                strcmd += string.Format(" PersonCode = {0}", data.PersonCode.ToString());
+                strcmd += string.Format(",ApprovalCode = {0}", data.ApprovalCode.ToString());
+                strcmd += string.Format(",OrderDate = TO_DATE('{0}','YYYY/MM/DD')", data.OrderDate.ToShortDateString());
+                strcmd += string.Format(",SeqNo = {0}", data.SeqNo.ToString());
+                strcmd += string.Format(",OrderNo = {0}", data.OrderNo.ToString());
+                strcmd += string.Format(",PersonCodeApproval = {0}", data.PersonCodeApproval.ToString());
+                strcmd += string.Format(",PetitionApprovalDate = TO_DATE('{0}','YYYY/MM/DD HH24:MI:SS')", data.PetitionApprovalDate.ToString());
+                strcmd += string.Format(",ApprovalLimitDates = TO_DATE('{0}','YYYY/MM/DD HH24:MI:SS')", data.ApprovalLimitDates.ToString());
+                strcmd += string.Format(",ApprovalStatus = {0}", data.ApprovalStatus.ToString());
+
+                strcmd += ", UpdateDate = TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+                strcmd += AddSQLString;
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ削除
+        /// <summary>
+        /// 承認データ削除
+        /// </summary>
+        /// <param name="AddSQLString">削除条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool DeleteAction(string AddSQLString, bool bConnect = true)
+        {
+            //Oracle インターフェース
+            string strcmd = "";
+            try
+            {
+                strcmd = string.Format("{0}{1}", "DELETE FROM PersonApproval", AddSQLString);
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 1項目更新処理
+        /// <summary>
+        /// 1項目の更新を行う
+        /// </summary>
+        /// <returns></returns>
+        public bool UpdateFeild(int PersonCode, int ApprovalCode, DateTime OrderDate, int FeildNo, object value, bool bConnect = true, int OrderNo = 0, int SeqNo = 0)
+        {
+            string strcmd = "";
+            try
+            {
+                strcmd = "UPDATE PersonApproval";
+
+                strcmd += " SET";
+                switch (FeildNo)
+                {
+                    case (int)ColumnName.PersonCode:
+                        strcmd += string.Format(" PersonCode = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.ApprovalCode:
+                        strcmd += string.Format(" ApprovalCode = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.OrderDate:
+                        strcmd += string.Format(" OrderDate = TO_DATE('{0}','YYYY/MM/DD')", ((DateTime)value).ToShortDateString());
+                        break;
+                    case (int)ColumnName.OrderNo:
+                        strcmd += string.Format(" OrderNo = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.SeqNo:
+                        strcmd += string.Format(" SeqNo = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.PersonCodeApproval:
+                        strcmd += string.Format(" PersonCodeApproval = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.PetitionApprovalDate:
+                        strcmd += string.Format(" PetitionApprovalDate = TO_DATE('{0}','YYYY/MM/DD')", ((DateTime)value).ToShortDateString());
+                        break;
+                    case (int)ColumnName.ApprovalLimitDates:
+                        strcmd += string.Format(" ApprovalLimitDates = TO_DATE('{0}','YYYY/MM/DD')", ((DateTime)value).ToShortDateString());
+                        break;
+                    case (int)ColumnName.ApprovalStatus:
+                        strcmd += string.Format(" ApprovalStatus = {0}", ((int)value).ToString());
+                        break;
+                }
+
+                strcmd += ", UpdateDate = TO_DATE(TO_CHAR(sysdate,'YYYY/MM/DD HH24:MI:SS'),'YYYY/MM/DD HH24:MI:SS')";
+                strcmd += CreatePrimarykeyString(PersonCode, ApprovalCode, OrderDate, OrderNo, SeqNo);
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region OracleDataReaderより構造体へセットする
+        /// <summary>
+        /// OracleDataReaderより構造体へセットする
+        /// </summary>
+        /// <param name="reader">OracleDataReader</param>
+        /// <param name="wrk">構造体</param>
+        public void Reader2Struct(object[] objwrk, ref PersonApproval wrk)
+        {
+            try
+            {
+                // データ取得
+                wrk.PersonCode = int.Parse(objwrk[(int)ColumnName.PersonCode].ToString());
+                wrk.ApprovalCode = int.Parse(objwrk[(int)ColumnName.ApprovalCode].ToString());
+                wrk.OrderDate = DateTime.Parse(objwrk[(int)ColumnName.OrderDate].ToString());
+                wrk.OrderNo = int.Parse(objwrk[(int)ColumnName.OrderNo].ToString());
+                wrk.SeqNo = int.Parse(objwrk[(int)ColumnName.SeqNo].ToString());
+                wrk.PersonCodeApproval = int.Parse(objwrk[(int)ColumnName.PersonCodeApproval].ToString());
+                wrk.PetitionApprovalDate = DateTime.Parse(objwrk[(int)ColumnName.PetitionApprovalDate].ToString());
+                wrk.ApprovalLimitDates = DateTime.Parse(objwrk[(int)ColumnName.ApprovalLimitDates].ToString());
+                wrk.ApprovalStatus = int.Parse(objwrk[(int)ColumnName.ApprovalStatus].ToString());
+
+                wrk.EntryDate = DateTime.Parse(objwrk[(int)ColumnName.ENTRYDATE].ToString());
+                wrk.UpdateDate = DateTime.Parse(objwrk[(int)ColumnName.UPDATEDATE].ToString());
+            }
+            catch (OracleException oraex)
+            {
+                logger.ErrorFormat("オラクルエラー：{0}：{1}", CommonMotions.GetMethodName(), oraex.Message);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 主キー検索の文字列を返す
+        /// <summary>
+        /// 主キー検索の文字列を返す
+        /// </summary>
+        /// <param name="BusinessTypeCode"></param>
+        /// <returns>Where文字列</returns>
+        public string CreatePrimarykeyString(int PersonCode, int ApprovalCode, DateTime OrderDate, int OrderNo = 0, int SeqNo = 0, string APara = "")
+        {
+            string strWork = string.Empty;
+            try
+            {
+                strWork = string.Format(" Where {0}PersonCode = {1}", APara, PersonCode.ToString());
+                strWork += string.Format(" And {0}ApprovalCode = {1}", APara, ApprovalCode.ToString());
+                strWork += string.Format(" And {0}OrderDate = TO_DATE('{1}','YYYY/MM/DD')", APara, OrderDate.ToShortDateString());
+                if (OrderNo != 0)
+                    strWork += string.Format(" And {0}OrderNo = {1}", APara, OrderNo.ToString());
+                if (SeqNo != 0)
+                    strWork += string.Format(" And {0}SeqNo = {1}", APara, SeqNo.ToString());
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strWork);
+            }
+
+            return strWork;
+        }
+        #endregion
+
+        #region 受付番号の最大値を取得する
+        /// <summary>
+        /// 受付番号の最大値を取得する
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public int SelectMaxOrderNoCount(string AddSQLString, bool bConnect = true)
+        {
+            //Oracle インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+            int iRet = 0;
+            try
+            {
+                // SQL作成
+                strcmd = "SELECT NVL(MAX(OrderNo), 0) FROM PersonApproval" + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return iRet;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    if (objwrk[0].ToString().Equals("null"))
+                        iRet = 0;
+                    else
+                        iRet = int.Parse(objwrk[0].ToString());
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+            }
+            return iRet;
+        }
+        #endregion
+
+        #region 枝番の最大値を取得する
+        /// <summary>
+        /// 枝番の最大値を取得する
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public int SelectMaxSeqNoCount(string AddSQLString, bool bConnect = true)
+        {
+            //Oracle インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+            int iRet = 0;
+            try
+            {
+                // SQL作成
+                strcmd = "SELECT NVL(MAX(SeqNo), 0) FROM PersonApproval" + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return iRet;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    if (objwrk[0].ToString().Equals("null"))
+                        iRet = 0;
+                    else
+                        iRet = int.Parse(objwrk[0].ToString());
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+            }
+            return iRet;
+        }
+        #endregion
+    }
+}
